/*
 */
var g_socket=null
var serverTimeout=10 * 1000
var tid=0
var g_site = ''
var g_shift = false
var g_ctrl = false
var g_alt = false
var g_caps = false
prepareWebsocket()

function setDesktop( item )
{
   wsSend( '00', { desktop: item} )
}

function setSlide( item )
{
   wsSend( '01', { slide: item} )
}

function setTab( item )
{
   wsSend( '02', { tab: item} )
}

function hit( item )
{
   var normal = '#DDDDDD'
   var highlight = '#999999'
   var kid
   var shift
   var clearModifier = true
//console.log( item )
   switch( item )
   {
      case 19:
         wsSend( '80', { type: 'leave', text: '' } )
         break
      case 20:
         setDesktop( 1 )
         break
      case 63:  //caps
         if ( g_caps )
         {
            setKeyColor( 'key-' + item, normal )
            g_caps = false
         }
         else
         {
            setKeyColor( 'key-' + item, highlight )
            g_caps = true
         }
         break
      case 78:  //shift
      case 89:  //shift
         var back
         if ( g_shift )
         {
            g_shift = false
            back = normal
         }
         else
         {
            g_shift = true
            back = highlight
         }
         setKeyColor( 'key-78', back )
         setKeyColor( 'key-89', back )
         clearModifier = false
         break
      case 95:  //ctrl
      case 101:  //ctrl
         var back
         if ( g_ctrl )
         {
            g_ctrl = false
            back = normal
         }
         else
         {
            g_ctrl = true
            back = highlight
         }
         setKeyColor( 'key-95', back )
         setKeyColor( 'key-101', back )
         clearModifier = false
         break
      case 97:  //alt
      case 99:  //alt
         var back
         if ( g_alt )
         {
            g_alt = false
            back = normal
         }
         else
         {
            g_alt = true
            back = highlight
         }
         setKeyColor( 'key-97', back )
         setKeyColor( 'key-99', back )
         clearModifier = false
         break
      case 96:  //win
      case 10:  //super
         // ignore
         clearModifier = false
         break
      default:
         setKeyColor( 'key-' + item, highlight )
         setTimeout( setKeyColor( 'key-' + item, normal ), 500);
         if ( g_shift || g_caps ) shift = true
         else shift = false
         wsSend( '80', { type: 'key', text: item, shift: shift, ctrl: g_ctrl, alt: g_alt } )
         clearModifier = true
         break
   }
   if ( clearModifier )
   {
      if ( g_shift )
      {
         g_shift = false
         setKeyColor( 'key-78', normal )
         setKeyColor( 'key-89', normal )
      }
      if ( g_ctrl )
      {
         g_ctrl = false
         setKeyColor( 'key-95', normal )
         setKeyColor( 'key-101', normal )
      }
      if ( g_alt )
      {
         g_alt = false
         setKeyColor( 'key-97', normal )
         setKeyColor( 'key-99', normal )
      }
   }
}

function setKeyColor( kid, color )
{
//console.log( 'setKeyColor:' + kid + ' color:' + color )
   document.getElementById(kid).style.background = color
}

function prepareWebsocket()
{
   g_socket = new ReconnectingWebSocket( getWSURL('control'), 'control' )
   g_socket.reconnectInterval = 5000
   g_socket.maxReconnectInterval = 10000
   g_socket.timeoutInterval = 5000

   g_socket.onopen = function ()
   {
   }
   g_socket.onmessage = function (event)
   {
      var item = JSON.parse(event.data)
      switch( item.id )
      {
         case '99': // error response
            swalError( item.error )
            break
         case '01':
            displaySlide( item )
            break
         default:
            break
      }
   }
}

// common function to post text data to the server and process its response
function wsSend( id, data )
{
   tid = tid + 1
   if ( tid > 999 )
      tid = 0
   data.tid = tid
   data.id = id
   g_socket.send( JSON.stringify( data ) )
}

// assumes WS server is same URL as HTTP server but port is one more
function getWSURL( protocol )
{
   var pcol
   var u = document.URL
   var port
   var parse_url = /^(?:([A-Za-z]+):)?(\/{0,3})([0-9.\-A-Za-z]+)(?::(\d+))?(?:\/([^?#]*))?(?:\?([^#]*))?(?:#(.*))?$/;
   var result = parse_url.exec(u)
   var rstr

   g_site = result[1] + result[2] + result[3] + ':' + result[4]
   // We open the websocket encrypted if this page came on an
   // https:// url itself, otherwise unencrypted
   if (result[1] == "https")
   {
      pcol = "wss://"
   }
   else
   {
      pcol = "ws://"
   }
   port = parseInt( result[4] )
   // + "protocol" bit is for IE10 workaround
   rstr = pcol + result[3] + ':' + port + '/' + protocol
   return rstr
}

function swalError( text )
{
   swal(
   {
      title: 'Error!',
      text: text,
      icon: 'error',
   })
}
