/*
 * Mouse simulator
 */
var g_socket=null
var serverTimeout=10 * 1000
var tid=0
var g_site = ''
var g_shift = false
var g_ctrl = false
var g_alt = false
var g_caps = false
var g_drag = false

prepareWebsocket()

function clickMouseButton( item )
{
   wsSend( '22', { button: item} )
}

function toggleDrag( )
{
   var normal = '#DDDDDD'
   var highlight = '#999999'
   if ( g_drag )
   {
      g_drag = false
      document.getElementById('toggledrag').value = 'Drag Off'
      $('#toggledrag').removeClass('button-highlight')
   }
   else
   {
      g_drag = true
      document.getElementById('toggledrag').value = 'Drag On'
      $('#toggledrag').addClass('button-highlight')
   }
}

function allowDrop(ev)
{
   var xperc, yperc
   ev.preventDefault()
   xperc = getPercent( ev.x - ev.target.offsetLeft, ev.target.clientWidth )
   yperc = getPercent( ev.y - ev.target.offsetTop, ev.target.clientHeight )
//console.log('allowdrop to ' + xperc +',' + yperc )
   wsSend( '21', { xperc: xperc, yperc: yperc, drop: false, drag: false } )
}

function dragStart(ev)
{
   xperc = getPercent( ev.x - ev.target.offsetLeft, ev.target.clientWidth )
   yperc = getPercent( ev.y - ev.target.offsetTop, ev.target.clientHeight )
//console.log('startdrag to ' + xperc +',' + yperc )
   wsSend( '21', { xperc: xperc, yperc: yperc, drop: false, drag: g_drag } )
}

function drag(event)
{
}

function drop(ev)
{
   ev.preventDefault()
//console.log(ev)
   document.getElementById('myCursor').style.left= ev.x + "px"
   document.getElementById('myCursor').style.top= ev.y + "px"
   xperc = getPercent( ev.x - ev.target.offsetLeft, ev.target.clientWidth )
   yperc = getPercent( ev.y - ev.target.offsetTop, ev.target.clientHeight )
//console.log('allowdrop to ' + xperc +',' + yperc )
   wsSend( '21', { xperc: xperc, yperc: yperc, drop: true, drag: g_drag } )
}

function getPercent( pos, size )
{
   return pos / size * 100
}

function prepareWebsocket()
{
   g_socket = new ReconnectingWebSocket( getWSURL('control'), 'control' )
   g_socket.reconnectInterval = 5000
   g_socket.maxReconnectInterval = 10000
   g_socket.timeoutInterval = 5000

   g_socket.onopen = function ()
   {
   }
   g_socket.onmessage = function (event)
   {
      var item = JSON.parse(event.data)
      switch( item.id )
      {
         case '99': // error response
            swalError( item.error )
            break
         default:
            break
      }
   }
}

// common function to post text data to the server and process its response
function wsSend( id, data )
{
   tid = tid + 1
   if ( tid > 999 )
      tid = 0
   data.tid = tid
   data.id = id
   g_socket.send( JSON.stringify( data ) )
}

// assumes WS server is same URL as HTTP server but port is one more
function getWSURL( protocol )
{
   var pcol
   var u = document.URL
   var port
   var parse_url = /^(?:([A-Za-z]+):)?(\/{0,3})([0-9.\-A-Za-z]+)(?::(\d+))?(?:\/([^?#]*))?(?:\?([^#]*))?(?:#(.*))?$/;
   var result = parse_url.exec(u)
   var rstr

   g_site = result[1] + result[2] + result[3] + ':' + result[4]
   // We open the websocket encrypted if this page came on an
   // https:// url itself, otherwise unencrypted
   if (result[1] == "https")
   {
      pcol = "wss://"
   }
   else
   {
      pcol = "ws://"
   }
   port = parseInt( result[4] )
   // + "protocol" bit is for IE10 workaround
   rstr = pcol + result[3] + ':' + port + '/' + protocol
   return rstr
}

function swalError( text )
{
   swal(
   {
      title: 'Error!',
      text: text,
      icon: 'error',
   })
}
