/*
 */
var g_socket=null
var serverTimeout=10 * 1000
var tid=0
var g_site = ''
prepareWebsocket()

function displaySlide( item )
{
   var url = g_site + '/' + item.page
   window.location.href = item.page
}

function prepareWebsocket()
{
   g_socket = new ReconnectingWebSocket( getWSURL('slide'), 'slide' )
   g_socket.reconnectInterval = 5000
   g_socket.maxReconnectInterval = 10000
   g_socket.timeoutInterval = 5000

   g_socket.onopen = function ()
   {

   }
   g_socket.onmessage = function (event)
   {
      var item = JSON.parse(event.data)
      switch( item.id )
      {
         case '99': // error response
            swalError( item.error )
            break
         case '01':
            displaySlide( item )
            break
         default:
            break
      }
   }
}

// common function to post text data to the server and process its response
function wsSend( id, data )
{
   tid = tid + 1
   if ( tid > 999 )
      tid = 0
   data.tid = tid
   data.id = id
   g_socket.send( JSON.stringify( data ) )
}

// assumes WS server is same URL as HTTP server but port is one more
function getWSURL( protocol )
{
   var pcol
   var u = document.URL
   var port
   var parse_url = /^(?:([A-Za-z]+):)?(\/{0,3})([0-9.\-A-Za-z]+)(?::(\d+))?(?:\/([^?#]*))?(?:\?([^#]*))?(?:#(.*))?$/;
   var result = parse_url.exec(u)
   var rstr

   g_site = result[1] + result[2] + result[3] + ':' + result[4]
   // We open the websocket encrypted if this page came on an
   // https:// url itself, otherwise unencrypted
   if (result[1] == "https")
   {
      pcol = "wss://"
   }
   else
   {
      pcol = "ws://"
   }
   port = parseInt( result[4] )
   // + "protocol" bit is for IE10 workaround
   rstr = pcol + result[3] + ':' + port + '/' + protocol
   return rstr
}

function swalError( text )
{
   swal(
   {
      title: 'Error!',
      text: text,
      icon: 'error',
   })
}
